# INSTALL.PL

# Steps:
# - Checks Math::FFT, if not found, offers guiding through its
#   install
# - Asks for CSAH home directory, prepares csahdetect.pl, copies
#   .pl files and evd tables there
# - Asks for directory to place csahdetect.pl to run 

# Step 1: checking Math::FFT
my $checkfft=eval{
    require Math::FFT;
    Math::FFT->import();
    1;
};
if ($checkfft){
    print "You appear to have Math::FFT installed on your computer.\n";
}
else{
    print "You do not seem to have Math::FFT installed, would you like to try and install it now (by invoking 'sudo cpan Math::FFT')? (Y/N)\n";
    $YN=<>;
    if($YN=~/^y/i){
	print "Running 'sudo cpan Math::FFT'\n";
	system("sudo cpan Math::FFT");
    }
    else{
        print "Without Math::FFT, you will not be able to use the FT_CHARGE method. You can install it manually with CPAN or from source (from www.cpan.org). If you install it into a non-standard location, kindly remember to edit ft_charge.pl to include a link to the appropriate directory (e.g. '#!/usr/bin/perl -I/somedir/').\n"; 
    }
}

# Setting CSAH home directory
$USER=`whoami`;chop($USER);
print "Enter the name of the CSAH directory where the scan4csah.pl, ft_charge.pl and the evd tables will be put (/home/$USER/.CSAH):\n";
$CSAHDIR=<>;
if ($CSAHDIR =~ /^$/){$CSAHDIR="/home/$USER/.CSAH"}
if (!-e $CSAHDIR){system "mkdir $CSAHDIR"}
system "cp scan4csah.pl ft_charge.pl *evdtable.txt $CSAHDIR/";

#Preparing csahdetect.pl executable
$PL=`which perl`;chop($PL);
print "Enter the name of the CSAH directory where the csahdetect.pl executable should be installed (/home/$USER/bin):\n";
 
$CBINDIR=<>;
if ($CBINDIR =~ /^$/){$CBINDIR="/home/$USER/bin"}
if (!-e $CBINDIR){system "mkdir $CBINDIR";print "$CBINDIR did not exist, please make sure to add the directory to your PATH!\n"}
$PL=~s%\/%\\/%g;
$CSAHDIR=~s%\/%\\/%g;

#print "sed 's/PERL/$PL/' < csahdetect.pk | sed 's/CSAHDIR/$CSAHDIR/' > $CBINDIR/csahdetect.pl\n";
system "sed 's/PERL/\#\!$PL/' < csahdetect.pk | sed 's/CSAH_DIRECTORY/\"$CSAHDIR\"/' > $CBINDIR/csahdetect.pl";
system "chmod +x $CBINDIR/csahdetect.pl";

print "Installation finished. If everything was fine, you can now invoke csahdetect.pl -h for usage.\n";


